﻿using System;
using System.ServiceModel;
using System.Transactions;
using System.Data;
using System.Data.SqlClient;

namespace TxServiceApp
{
	[ServiceContract]
	interface ITxService
	{
		[OperationContract]
		int InsertData(int val);
	}

	[ServiceBehavior(TransactionIsolationLevel = System.Transactions.IsolationLevel.ReadCommitted,
					 TransactionTimeout = "00:02:00")]
	class TxService : ITxService
	{
		[OperationBehavior(TransactionScopeRequired = true)]
		public int InsertData(int val)
		{
			System.Diagnostics.Debug.Assert(Transaction.Current != null);

			string connStr = "SERVER=(local);Trusted_Connection=true;DATABASE=TestDB";
			string query = "INSERT INTO TestTable VALUES(@val, 'TempData'); " +
						"SELECT @@IDENTITY";
			SqlConnection conn = new SqlConnection(connStr);
			SqlCommand cmd = new SqlCommand(query, conn);

			conn.Open();
			cmd.Parameters.Add("@val", SqlDbType.Int, 4).Value = val;
			try {
				decimal id = (decimal)cmd.ExecuteScalar();
				Console.WriteLine("New data id = {0}", id);
				return (int)id;
			}
			finally {
				conn.Close();
			}
		}
	}

	class ServiceApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Transactional Service Sample......");

			ServiceHost host = new ServiceHost(typeof(TxService));
			host.Open();
			Console.WriteLine("The service started... Press any key to stop...");
			Console.ReadKey(true);
			host.Close();
		}
	}
}
