﻿using System;
using System.ServiceModel;
using System.Messaging;
using MsmqClientApp.MsmqService;

namespace MsmqClientApp
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Journaling Test Client Sample.....");

			Console.WriteLine("Before service invoke...");
			ShowSystemJournalQueue();
			Console.WriteLine();
			using (MsmqServiceClient proxy = new MsmqServiceClient()) {
				((NetMsmqBinding)proxy.Endpoint.Binding).UseSourceJournal = true;
				proxy.TestMethod("Test Service Call...");
				Console.WriteLine("Invoke service...");
			}
			Console.WriteLine();
			Console.WriteLine("After service invoke...");
			ShowSystemJournalQueue();
		}

		static void ShowSystemJournalQueue()
		{
			string queuePath = "FORMATNAME:DIRECT=OS:.\\system$;journal";
			MessageQueue queue = new MessageQueue(queuePath);
			Console.WriteLine("  Inspecting journal queue : {0}", queue.Path);

			// GetAllMessages는 메시지를 큐에서 제거하지 않는다(PEEK)
			Message[] msgs = queue.GetAllMessages();
			Console.WriteLine("  Message count : {0}", msgs.Length);
			for (int i = 0; i < msgs.Length; i++) {
				Console.WriteLine("   Msg #{0} : Id={1}", i, msgs[i].Id);
			}
		}
	}
}
