﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.Messaging;

namespace BasicMsmqServiceApp
{
	[ServiceContract]
	[DeliveryRequirements(QueuedDeliveryRequirements = QueuedDeliveryRequirementsMode.Required)]
	interface IQueuedContract
	{
		[OperationContract(IsOneWay = true)]
		void AsyncOneWayMethod(string arg0, DateTime arg1);
	}

	class QueuedService : IQueuedContract
	{
		public void AsyncOneWayMethod(string arg0, DateTime arg1)
		{
			Console.WriteLine("Service method invoked... arg0={0}, arg1={1}", arg0, arg1);
		}
	}


	class ServiceApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Simple MSMQ-based WCF Service Sample......");

			// 메시지 큐가 존재하는지 확인하고 존재하지 않으면 생성한다.
			if (MessageQueue.Exists(".\\private$\\wcftest") == false) {
				MessageQueue.Create(".\\private$\\wcftest", true);
			}

			//
			// 프로그램 코드 사용시 호스트 설정 코드
			//
			//NetMsmqBinding binding = new NetMsmqBinding();
			//binding.Security.Mode = NetMsmqSecurityMode.None;

			//ServiceMetadataBehavior behavior = new ServiceMetadataBehavior();
			//behavior.HttpGetEnabled = true;

			//ServiceHost host = new ServiceHost(typeof(QueuedService),
			//    new Uri("net.msmq://localhost/private/wcftest"),
			//    new Uri("http://localhost/wcf/example/msmq/basic"));
			//host.AddServiceEndpoint(typeof(IQueuedContract), binding, "");
			//host.Description.Behaviors.Add(behavior);

			//
			// Configuration 사용시 호스트 설정 코드
			//
			ServiceHost host = new ServiceHost(typeof(QueuedService));

			// 서비스 구동
			host.Open();
			Console.WriteLine("The service started. Press any key to stop...");
			Console.ReadKey(true);
			host.Close();
		}
	}
}
