﻿using System;
using System.Collections.Generic;
using System.Text;
using SecureClientApp.SecureService;
using System.Net;
using System.Security.Cryptography.X509Certificates;

namespace SecureClientApp
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("TCP Transport Security Test Client......");

			//CallWithAnonymousCredential();
			//CallWithWindowsCredential();
			CallWithCertificateCredential();
		}

		static void CallWithAnonymousCredential()
		{
			using (SecureServiceClient proxy = new SecureServiceClient()) {
				proxy.SecureMethod("Anonymous call");
			}
		}

		static void CallWithWindowsCredential()
		{
			using (SecureServiceClient proxy = new SecureServiceClient()) {
				proxy.SecureMethod("Windows call");
			}
		}

		static void CallWithCertificateCredential()
		{
			using (SecureServiceClient proxy = new SecureServiceClient()) {
				proxy.ClientCredentials.ClientCertificate.SetCertificate(
					"CN=TestUser", StoreLocation.CurrentUser, StoreName.My);
				proxy.SecureMethod("Certificate call");
			}
		}
	}
}
