﻿using System;
using System.ServiceModel;
using System.ServiceModel.Description;
using System.ServiceModel.Dispatcher;
using System.ServiceModel.Channels;
using System.ServiceModel.Configuration;
using System.Collections.ObjectModel;

namespace UserInfoExtension
{
	public class UserInfoBehavior : BehaviorExtensionElement, IServiceBehavior, IEndpointBehavior
	{
		#region "IEndpointBehavior 인터페이스 구현"

		public void AddBindingParameters(ServiceEndpoint endpoint, BindingParameterCollection bindingParameters)
		{
		}

		public void ApplyClientBehavior(ServiceEndpoint endpoint, ClientRuntime clientRuntime)
		{
			clientRuntime.MessageInspectors.Add(new UserInfoMessageInspector());
		}

		public void ApplyDispatchBehavior(ServiceEndpoint endpoint, EndpointDispatcher endpointDispatcher)
		{
			endpointDispatcher.DispatchRuntime.MessageInspectors.Add(
				new UserInfoMessageInspector());
		}

		public void Validate(ServiceEndpoint endpoint)
		{
			// do nothing
		}

		#endregion

		#region "IServiceBehavior 인터페이스 구현"

		public void AddBindingParameters(ServiceDescription serviceDescription,
				ServiceHostBase serviceHostBase, Collection<ServiceEndpoint> endpoints,
				BindingParameterCollection bindingParameters)
		{
		}

		public void ApplyDispatchBehavior(ServiceDescription serviceDescription,
				ServiceHostBase serviceHostBase)
		{
			foreach (ServiceEndpoint ep in serviceHostBase.Description.Endpoints) {
				ep.Behaviors.Add(new UserInfoBehavior());
			}
		}

		public void Validate(ServiceDescription serviceDescription,
			ServiceHostBase serviceHostBase)
		{
		}

		#endregion

		#region "BehaviorExtensionElement 구현"

		public override Type BehaviorType
		{
			get { return this.GetType(); }
		}

		protected override object CreateBehavior()
		{
			return new UserInfoBehavior();
		}

		#endregion
	}
}
