﻿using System;
using System.ServiceModel;

namespace HelloWorldClient3
{
	//
	// Hello World 서비스 클라이언트 구현
	// (svcutil.exe 를 이용한 프록시 생성)
	//
	class ClientApp3
	{
		static void Main(string[] args)
		{
			ClientSample1();
			ClientSample2();
			ClientSample3();
		}

		// Configuration을 사용하지 않고 코드 사용
		static void ClientSample1()
		{
			string url = "http://localhost/wcf/example/helloworldservice";
			BasicHttpBinding binding = new BasicHttpBinding();
			EndpointAddress epAddress = new EndpointAddress(url);

			binding.MessageEncoding = WSMessageEncoding.Mtom;
			using (HelloWorldClient proxy = new HelloWorldClient(binding, epAddress)) {
				string result = proxy.SayHello();
				Console.WriteLine(result);
			}
		}

		// Configuration 설정 사용
		static void ClientSample2()
		{
			using (HelloWorldClient proxy = new HelloWorldClient("BasicHttpBinding_IHelloWorld")) {
				// 다음과 같이 설정을 오버라이드 할 수도 있다.
				BasicHttpBinding binding = proxy.Endpoint.Binding as BasicHttpBinding;
				if (binding != null) {
					binding.MessageEncoding = WSMessageEncoding.Mtom;
				}
				string result = proxy.SayHello();
				Console.WriteLine(result);
			}
		}

		// NetTcpBinding 사용
		static void ClientSample3()
		{
			using (HelloWorldClient proxy = new HelloWorldClient("NetTcpBinding_IHelloWorld")) {
				string result = proxy.SayHello();
				Console.WriteLine(result);
			}
		}
	}
}
