﻿using System;
using System.ServiceModel;

namespace HelloWorldClient5
{
	[ServiceContract(Namespace = "http://www.simpleisbest.net/wcf/helloworld")]
	public interface IHelloWorld
	{
		[OperationContract]
		string SayHello();
	}

	// 수작업으로 작성한 프록시 코드
	public class MyProxy : ClientBase<IHelloWorld>, IHelloWorld
	{
		public MyProxy(string configurationName)
			: base(configurationName)
		{
		}

		public string SayHello()
		{
			return base.Channel.SayHello();
		}
	}

	//
	// Hello World 서비스 클라이언트 구현
	//
	class ClientApp5
	{
		static void Main(string[] args)
		{
			// 직접 작성한 프록시 사용
			using (MyProxy proxy =
						new MyProxy("BasicHttpBinding_IHelloWorld")) {
				//proxy.Endpoint.Address =
				//    new EndpointAddress("http://localhost:51551/HelloWorld.svc");
				string result = proxy.SayHello();
				Console.WriteLine(result);
			}
		}
	}
}
