﻿using System;
using System.Data;
using System.Web;
using System.Collections;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.ComponentModel;

using System.Collections.Generic;

namespace AsmxCollectionService
{
	[WebService(Namespace = "http://noname.com/collection/asmx")]
	[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
	[ToolboxItem(false)]
	[DesignerCategory("Code")]
	public class CollectionTest : System.Web.Services.WebService
	{
		[WebMethod]
		public ArrayList GetList1()
		{
			ArrayList list = new ArrayList();
			list.Add("Hello");
			list.Add("ASXM");
			list.Add("World");
			return list;
		}

		[WebMethod]
		public ArrayList GetList2()
		{
			ArrayList list = new ArrayList();
			list.Add(new CustomType(1));
			list.Add(new CustomType(2));
			list.Add(new CustomType(3));
			return list;
		}

		[WebMethod]
		public List<CustomType> GetList3()
		{
			List<CustomType> list = new List<CustomType>();
			list.Add(new CustomType(1));
			list.Add(new CustomType(2));
			list.Add(new CustomType(3));
			return list;
		}

		// 다음 메쏘드는 IDictionary를 지원하므로 ASMX 에서 사용할 수 없다.
		[WebMethod]
		public Dictionary<int, string> GetDictionary1()
		{
			Dictionary<int, string> dictionary = new Dictionary<int, string>();

			dictionary.Add(0, "Hello");
			dictionary.Add(1, "ASMX");
			dictionary.Add(2, "World");

			return dictionary;
		}

		// 다음 메쏘드 역시 MyDictionary가 IDictionary를 구현하므로 ASMX에서
		// 사용할 수 없다.
		[WebMethod]
		public MyDictionary GetDictionary2()
		{
			MyDictionary dictionary = new MyDictionary();

			dictionary.Add(0, "Hello");
			dictionary.Add(1, "ASMX");
			dictionary.Add(2, "World");

			return dictionary;
		}
	}

	public class CustomType
	{
		public int a;

		public CustomType()
		{ a = 0; }
		public CustomType(int val)
		{ a = val; }
	}

	public class MyDictionary : Dictionary<int, string>
	{
	}
}
