﻿using System;
using System.Collections;
using System.Collections.Generic;

using CollectionDataContractClient.Test;

namespace CollectionDataContractClient
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Collection Data Contract Client Example...");

			using (CollectionTestClient proxy = new CollectionTestClient()) {
				string[] s1 = proxy.GetStrings();
				Console.Write("Result of GetStrings() = ");
				foreach (string s in s1) {
					Console.Write(s);
					Console.Write("  ");
				}
				Console.WriteLine();

				CustomType[] c1 = proxy.GetCustomTypes();
				Console.Write("Result of GetCustomTypes() = ");
				foreach (CustomType c in c1) {
					Console.Write(c.a);
					Console.Write("  ");
				}
				Console.WriteLine();

				object[] o1 = proxy.GetSimpleObjects();
				Console.Write("Result of GetSimpleObjects() = ");
				foreach (string s in o1) {
					Console.Write(s);
					Console.Write("  ");
				}
				Console.WriteLine();

				object[] o2 = proxy.GetCustomObjects();
				Console.Write("Result of GetCustomObjects() = ");
				foreach (CustomType c in o2) {
					Console.Write(c.a);
					Console.Write("  ");
				}
				Console.WriteLine();

				CustomType[] c2 = proxy.GetCustomObjectsTyped();
				Console.Write("Result of GetCustomObjectsTyped() = ");
				foreach (CustomType c in c2) {
					Console.Write(c.a);
					Console.Write("  ");
				}
				Console.WriteLine();

				object[] s2 = proxy.GetStringList();
				Console.Write("Result of GetStringList() = ");
				foreach (string s in s2) {
					Console.Write(s);
					Console.Write("  ");
				}
				Console.WriteLine();

				object[] o3 = proxy.GetCustomObjectList();
				Console.Write("Result of GetCustomObjectList() = ");
				foreach (CustomType c in o3) {
					Console.Write(c.a);
					Console.Write("  ");
				}
				Console.WriteLine();

				CustomType[] c3 = proxy.GetCustomObjectListTyped();
				Console.Write("Result of GetCustomObjectListTyped() = ");
				foreach (CustomType c in c3) {
					Console.Write(c.a);
					Console.Write("  ");
				}
				Console.WriteLine();

				object[] o4 = proxy.GetCustomObjectCollection();
				Console.Write("Result of GetCustomObjectCollection() = ");
				foreach (CustomType c in o4) {
					Console.Write(c.a);
					Console.Write("  ");
				}
				Console.WriteLine();

				CustomType[] c4 = proxy.GetCustomObjectCollectionTyped();
				Console.Write("Result of GetCustomObjectCollection() = ");
				foreach (CustomType c in c4) {
					Console.Write(c.a);
					Console.Write("  ");
				}
				Console.WriteLine();


				object[] o5 = proxy.GetArrayList();
				Console.Write("Result of GetArrayList() = ");
				foreach (string s in o5) {
					Console.Write(s);
					Console.Write("  ");
				}
				Console.WriteLine();

				object[] o6 = proxy.GetCustomObjectArrayList();
				Console.Write("Result of GetCustomObjectArrayList() = ");
				foreach (CustomType c in o6) {
					Console.Write(c.a);
					Console.Write("  ");
				}
				Console.WriteLine();

				CustomType[] c5 = proxy.GetTypedList();
				Console.Write("Result of GetTypedList() = ");
				foreach (CustomType c in c5) {
					Console.Write(c.a);
					Console.Write("  ");
				}
				Console.WriteLine();

				Dictionary<object, object> d1 = proxy.GetDictionary();
				Console.Write("Result of GetDictionary() = ");
				foreach (KeyValuePair<object, object> pair in d1) {
					Console.Write("{0}:{1}  ", pair.Key, pair.Value);
				}
				Console.WriteLine();

				Dictionary<object, object> d2 = proxy.GetHashtable();
				Console.Write("Result of GetHashtable() = ");
				foreach (int key in d2.Keys) {
					Console.Write("{0}:{1}  ", key, ((CustomType)d2[key]).a);
				}
				Console.WriteLine();

				Dictionary<int, CustomType> d3 = proxy.GetDictionaryTyped();
				Console.Write("Result of GetDictionaryTyped() = ");
				foreach (int key in d3.Keys) {
					Console.Write("{0}:{1}  ", key, d3[key].a);
				}
				Console.WriteLine();

				Dictionary<object, object> d4 = proxy.GetCustomDictionary1();
				Console.Write("Result of GetCustomDictionary1() = ");
				foreach (string key in d4.Keys) {
					Console.Write("{0}:{1}  ", key, ((CustomType)d4[key]).a);
				}
				Console.WriteLine();

				MyDictionary2 d5 = proxy.GetCustomDictionary2();
				Console.Write("Result of GetCustomDictionary2() = ");
				foreach (string key in d5.Keys) {
					Console.Write("{0}:{1}  ", key, d5[key].a);
				}
				Console.WriteLine();
			}
		}
	}
}
