﻿using System;
using System.Runtime.Serialization;

namespace DataContractLibrary
{
	[DataContract(Namespace = "http://noname.com/bookstore/data")]
	public class BookInfo
	{
		[DataMember]
		public string Title;
		[DataMember]
		public string Isbn;
		[DataMember]
		public string Author;
		[DataMember]
		public int Price;
		[DataMember]
		public double MarginRate;

		public BookInfo(string title, string isbn, string author, int price)
		{
			Title = title;
			Isbn = isbn;
			Author = author;
			Price = price;
			MarginRate = 0.25;
		}

		public double GetMaxDiscountPrice()
		{
			return this.Price - this.Price * this.MarginRate;
		}
	}

}
