﻿using System;
using System.ServiceModel;
using System.ServiceModel.Description;

using CustomizingWSHttpBindingClient.MyService;

namespace CustomizingWSHttpBindingClient
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Customizing WSHttpBinding Sample Client......");

			// Configuration 설정을 사용하지 않고 코드에 의해 바인딩을 생성하고
			// 사용하였다.
			WSHttpBinding binding = new WSHttpBinding();
			binding.Security.Mode = SecurityMode.None;
			binding.ReliableSession.Enabled = true;

			EndpointAddress remoteAddress = new EndpointAddress(
				"http://loner/wcf/example/myservice");

			using (MyContractClient proxy = new MyContractClient(binding, remoteAddress)) {
				string result = proxy.Echo("WSHttpBinding Message Echo");
				Console.WriteLine("Result = {0}", result);
			}
		}
	}
}
