﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration.Install;
using System.ServiceProcess;

namespace FileMonitorService
{
	// Windows 서비스 설치를 위한 Installer 클래스
	// (디자이너를 사용하지 않고 직접 코드를 작성하였다)
	[RunInstaller(true)]
	[DesignerCategory("Code")]
	public class FileMonSvcInstaller : Installer
	{
		public FileMonSvcInstaller()
		{
			// 서비스 프로세스 인스톨러 설정
			ServiceProcessInstaller processInstaller = new ServiceProcessInstaller();
			processInstaller.Account = ServiceAccount.LocalSystem;
			processInstaller.Username = null;
			processInstaller.Password = null;
			this.Installers.Add(processInstaller);

			// 서비스 인스톨러 설정
			ServiceInstaller serviceInstaller = new ServiceInstaller();
			serviceInstaller.ServiceName = "SampleFileMonSvc";
			serviceInstaller.DisplayName = "Sample Service for NetNamedPipeBinding";
			serviceInstaller.Description = "NetNamedPipeBinding의 사용 예를 보이기 위한 예제 서비스";
			serviceInstaller.StartType = ServiceStartMode.Manual;
			this.Installers.Add(serviceInstaller);
		}
	}
}