﻿using System;
using System.ServiceModel;
using System.ServiceModel.Dispatcher;

namespace ExceptionServiceApp
{
	// 사용자 정의 ServiceHost 클래스 정의
	class MyServiceHost : ServiceHost
	{
		public MyServiceHost(Type serviceType)
			: base(serviceType)
		{
		}

		// WCF 런타임 초기화
		protected override void InitializeRuntime()
		{
			base.InitializeRuntime();
			// 에러 핸들러를 추가한다.
			MyErrorHandler handler = new MyErrorHandler();
			foreach (ChannelDispatcher dispatcher in this.ChannelDispatchers) {
				dispatcher.ErrorHandlers.Add(handler);
			}
		}
	}
}
