﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;

namespace ServiceWithUI
{
	[ServiceContract]
	interface ILog
	{
		[OperationContract]
		void LogMessage(string message);
	}

	[ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall,
					ConcurrencyMode = ConcurrencyMode.Multiple,
					UseSynchronizationContext = true,
					IncludeExceptionDetailInFaults = true)]
	class LogService : ILog
	{
		private static int _CallCount = 0;

		public void LogMessage(string message)
		{
			_CallCount++;
			ServiceUIForm frm = (ServiceUIForm)System.Windows.Forms.Application.OpenForms["ServiceUIForm"];
			frm.ShowLogMessage(_CallCount, message);
			System.Threading.Thread.Sleep(3000);
		}
	}
}
