﻿using System;
using System.ServiceModel;

using SessionfulClientApp.SessionfulService;

namespace SessionfulClientApp
{
	class ClientApp
	{
		static void Main(string[] args)
		{
			Console.WriteLine("Basic Session Test Client......");

			int count = 0;
			SessionfulClient proxy = new SessionfulClient("NetTcpBinding_ISessionful");
			SessionfulClient proxy2 = new SessionfulClient("NetTcpBinding_ISessionful");
			try {
				proxy.Open();
				Console.WriteLine("Now session is created...");
				proxy2.Open();
				Console.WriteLine("Now session2 is created...");
				count = proxy.TestMethod1();
				Console.WriteLine("proxy.TestMethod1() result = {0}", count);
				count = proxy2.TestMethod1();
				Console.WriteLine("proxy2.TestMethod1() result = {0}", count);
				count = proxy.TestMethod2();
				Console.WriteLine("proxy.TestMethod2() result = {0}", count);
				count = proxy2.TestMethod2();
				Console.WriteLine("proxy2.TestMethod2() result = {0}", count);
			}
			catch (FaultException ex) {
				Console.WriteLine("Error: {0}", ex.Message);
				proxy.Abort();
			}
			finally {
				if (proxy.State != CommunicationState.Closed) {
					proxy.Close();
				}
				Console.WriteLine("The session is closed...");
				if (proxy2.State != CommunicationState.Closed) {
					proxy2.Close();
				}
				Console.WriteLine("The session2 is closed...");
			}
		}
	}
}
