﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using System.Threading;

namespace TestServiceApp
{
	[ServiceContract]
	interface ISingletonService
	{
		[OperationContract]
		void TestMethod(int delay);
	}

	[ServiceBehavior(InstanceContextMode = InstanceContextMode.Single,
					ConcurrencyMode = ConcurrencyMode.Single)]
	class SingletonService : ISingletonService
	{
		private int _CallCount;

		public void TestMethod(int delay)
		{
			_CallCount++;
			Console.WriteLine("TestMethod Invoked... call count={0}", _CallCount);
			Thread.Sleep(delay);
		}
	}
}
