﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.ServiceModel;

namespace TestServiceApp
{
	[ServiceContract]
	interface ISingletonService
	{
		[OperationContract]
		void TestMethod(int delay);
	}

	[ServiceBehavior(InstanceContextMode = InstanceContextMode.Single, ConcurrencyMode = ConcurrencyMode.Multiple)]
	class SingletonService : ISingletonService, IDisposable
	{
		private static int _ObjectCount = 0;

		public SingletonService()
		{
			Interlocked.Increment(ref _ObjectCount);
			Console.WriteLine("++ SingletonService object created, count={0}", _ObjectCount);
		}

		public void Dispose()
		{
			Interlocked.Decrement(ref _ObjectCount);
			Console.WriteLine("-- SingletonService object released, count={0}", _ObjectCount);
		}

		public void TestMethod(int delay)
		{
			Thread.Sleep(delay);
		}
	}
}
