﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;

namespace TestServiceApp
{
	[ServiceContract]
	interface ILog
	{
		[OperationContract(IsOneWay = true)]
		void LogMessage(string message);

		[OperationContract(IsOneWay = true)]
		void LogMessageWithError();
	}

	[ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall)]
	class LogService : ILog
	{
		public void LogMessage(string message)
		{
			Console.WriteLine("Log: {0}", message);
			System.Threading.Thread.Sleep(3000);
		}

		public void LogMessageWithError()
		{
			Console.WriteLine("InvalidOperationException will be thrown");

			InvalidOperationException ex = new InvalidOperationException("테스트를 위한 강제 예외");
			throw ex;
			//throw new FaultException<ExceptionDetail>(new ExceptionDetail(ex));
		}
	}
}
